/*
   Coolpix RAW to Coolpix NEF converter
   by paul69, v0.04, 2003-01-26, <e2500@narod.ru>

   RAW Data Reader 

   Supported camera (tested)
      E2500
      E4500
      E995
*/

#include <stdio.h>
#include <string.h>
#pragma hdrstop

#include "raw2nef.h"

bool read_raw(FILE* in, color_t ccd[], TCCDParam& ccd_pars)
{
   unsigned ccd_size = ccd_pars.raw_width * ccd_pars.raw_height;

   for(int f=0; f<2; ++f)
   {
      if( ccd_pars.field[f].rows == 0 ) continue;

      fseek( in, ccd_pars.field[f].offset, SEEK_SET );

      unsigned raw_width = ccd_pars.raw_width;
      unsigned line = f * raw_width;
      unsigned delta = 2 * raw_width;
      unsigned field_size = ccd_pars.field[f].rows * raw_width*12/8;

      unsigned i, x;

      for(x=i=0; i<field_size; i += 3)
      {
         byte bitbuf[3];
         if( !fread( bitbuf, 3, 1, in) )
            return false;

         if( x == raw_width )
         {
            line += delta;
            x = 0;

            // check space for row
            if( line + raw_width > ccd_size )
               return false;
         }

         ccd[line + x] = (color_t)(((bitbuf[0]<<4)|((bitbuf[1]>>4)&15)));
         ++x;

         ccd[line + x] = (color_t)((((bitbuf[1]&15)<<8)|(bitbuf[2])));
         ++x;
      }
   }
   return true;
}

